Subject: Re: [rfh] where is coccinelle these days on Ubuntu?

From: Taylor Blau <[email-masked]>
Date: Mon, 8 Feb 2021 16:22:34 -0500

On Sat, Feb 06, 2021 at 10:49:08AM -0800, Junio C Hamano wrote:
> Taylor Blau <[email-masked]> writes:
>
> > From a quick search, it looks like coccinelle was moved to the
> > "universe" repository, at least in the Azure mirrors (which is what
> > GitHub Actions uses):
> >
> >     http://azure.archive.ubuntu.com/ubuntu/pool/universe/c/coccinelle/
>
> Unfortunately the pool/ system does not tell us which suite a
> package is available in (that's the whole point of it, as it lets
> them share the packages across suites without moving things around).

OK. I'm learning about this as I go, so this is helpful to know it's not
good practice to pin a specific suite.

> Looking for the package availability
>
>   https://packages.ubuntu.com/search?keywords=coccinelle
>
> seems to tell me about these:

It seems that there isn't a coccinelle package available for focal yet.
That's odd, since (1) focal is a LTS release, and (2) there *is* a
coccinelle package on groovy, which is newer than focal. Here's a piece
of mail from the coccinelle list that says there's no release yet.

    https://systeme.lip6.fr/pipermail/cocci/2020-June/007768.html

Our static-analysis build runs on 'ubuntu-latest', which I understand is
in the process of being upgraded from bionic to focal (I was pointed to
https://github.com/actions/virtual-environments/issues/1816 internally
as a spot to learn more about this.)

Double checking the latest successful static-analysis build, indeed it
was on 18.04:

    https://github.com/git/git/runs/1811069070?check_suite_focus=true

> Hmph...

So, I guess we could continue to run on 18.04 until there is a focal
coccinelle. Below would be the way to do that...

Thanks,
Taylor

--- >8 ---

Subject: [PATCH] .github/workflows/main.yml: run static-analysis on bionic

GitHub Actions is transitioning workflow steps that run on
'ubuntu-latest' from 18.04 to 20.04 [1].

This works fine in all steps except the static-analysis one, since
Coccinelle isn't available on Ubuntu focal (it is only available in the
universe suite).

Until Coccinelle can be installed from 20.04's main suite, pin the
static-analysis build to run on 18.04, where it can be installed by
default.

[1]: https://github.com/actions/virtual-environments/issues/1816

Reported-by: Junio C Hamano <[email-masked]>
Signed-off-by: Taylor Blau <[email-masked]>
---
 .github/workflows/main.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/.github/workflows/main.yml b/.github/workflows/main.yml
index f6885e88ee..a3fbbe6398 100644
--- a/.github/workflows/main.yml
+++ b/.github/workflows/main.yml
@@ -340,7 +340,7 @@ jobs:
     if: needs.ci-config.outputs.enabled == 'yes'
     env:
       jobname: StaticAnalysis
-    runs-on: ubuntu-latest
+    runs-on: ubuntu-18.04
     steps:
     - uses: actions/checkout@v1
     - run: ci/install-dependencies.sh
--
2.30.0.667.g81c0cbc6fd